#include "aliases.h"
#include "mem_allocator.h"
#include "mem_ctx.h"
#include "tiffread.h"
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[]) {
  wapp_mem_ctx_init(10 * 1024 * 1024, 2 * 1024 * 1024);
  Allocator ctx_main_allocator = wapp_mem_ctx_allocator(CTX_DEST_BUFFER_MAIN);
  Allocator ctx_temp_allocator = wapp_mem_ctx_allocator(CTX_DEST_BUFFER_TEMP);
  (void)(ctx_temp_allocator);

  const char *file_to_open = argc > 1 ? argv[1] : "./resources/test.tif";

  read_baseline_tiff(file_to_open, &ctx_main_allocator);

  // FILE *fp = fopen(file_to_open, "rb");

  // TiffHdr header;
  // fread(&header, sizeof(header), 1, fp);

  // TiffIFD ifd = {0};

  // printf("ORDER: %04x\n", header.order);
  // printf("MAGIC: %04x\n", header.magic);

  // fseek(fp, header.first_ifd_offset, SEEK_SET);

  // fread(&(ifd.count), sizeof(ifd.count), 1, fp);

  // printf("COUNT: %u\n", ifd.count);

  // TiffField fields[ifd.count];
  // memset(fields, 0, sizeof(TiffField) * ifd.count);

  // for (u32 i = 0; i < ifd.count; ++i) {
  //   fread(fields + i, sizeof(TiffField), 1, fp);
  //   printf("ENTRY %02u (%lu)\n", i, ftell(fp));
  //   printf("\t    TAG: %04u (%s)\n", fields[i].tag,
  //          tag_names[fields[i].tag] ? tag_names[fields[i].tag] : "UNKNOWN");
  //   printf("\t   TYPE: 0x%04x (%s)\n", fields[i].type,
  //          field_types[fields[i].type].name ?
  //          field_types[fields[i].type].name
  //                                           : "UNKNOWN");
  //   printf("\t  COUNT: %04u\n", fields[i].count);
  //   printf("\tVAL/OFF: %04u\n", fields[i].value_offset);
  // }

  wapp_mem_ctx_free();

  return 0;
}
